package eu.eudat.query.engine.expressions;

import eu.eudat.query.engine.types.expression.comparison.ComparisonExpressionType;

/**
 * Created by ikalyvas on 7/5/2018.
 */
public class ComparisonExpression extends AbstractFieldExpression<ComparisonExpression> implements Expression {

    private ComparisonExpressionType type;
    private Object value;

    public <T> Expression greaterThan(T value){
        this.value = value;
        this.type = ComparisonExpressionType.GREATER_THAN;
        return this;
    }

    public <T> Expression greaterThanOrEqual(T value){
        this.value = value;
        this.type = ComparisonExpressionType.GREATER_OR_EQUAL_THAN;
        return this;
    }

    public <T> Expression equal(T value){
        this.value = value;
        this.type = ComparisonExpressionType.EQUAL;
        return this;
    }

    public <T> Expression lessThan(T value){
        this.value = value;
        this.type = ComparisonExpressionType.LESS_THAN;
        return this;
    }

    public <T> Expression lessOrEqualThan(T value){
        this.value = value;
        this.type = ComparisonExpressionType.LESS_OR_EQUAL_THAN;
        return this;
    }

    @Override
    public String evaluate() {
        return this.getField() +" " + type.toString() + " " + value ;
    }
}
