import { ViewEncapsulation, Component, Inject } from "@angular/core";
import { MatDialogRef, MAT_DIALOG_DATA } from "@angular/material";
import { FormGroup } from "@angular/forms";
import { DatasetProfileDefinitionModel } from "../../models/DatasetProfileDefinitionModel";
import { JsonSerializer } from "../../utilities/JsonSerializer";
import { DatasetModel } from "../../models/datasets/DatasetModel";
import { DatasetWizardModel } from "../../models/datasets/DatasetWizardModel";
import { DatasetProfileService } from "../../services/dataset-profile.service";
import { DatasetProfileAdmin } from "../../services/datasetProfileAdmin/datasetProfileAfmin.service";

@Component({
  selector: 'dataset-profile-previewer',
  templateUrl: './dataset-profile-previewer.component.html',
  styleUrls: ['./dataset-profile-previewer.component.scss'],
  encapsulation: ViewEncapsulation.None
})

export class DatasetProfilePreviewerComponent {
  formGroup: FormGroup
  datasetWizardModel: DatasetWizardModel
  constructor(
    private datasetProfileAdminService: DatasetProfileAdmin,
    public dialogRef: MatDialogRef<DatasetProfilePreviewerComponent>,
    @Inject(MAT_DIALOG_DATA) public data: any
  ) { }

  ngOnInit(): void {

    this.datasetProfileAdminService.preview(this.data['model']).subscribe(x => {
      this.datasetWizardModel = new DatasetWizardModel();
      this.datasetWizardModel.datasetProfileDefinition = JsonSerializer.fromJSONObject(x, DatasetProfileDefinitionModel)
      this.formGroup = this.datasetWizardModel.buildForm();
    })

  }
}
