import { Component, ViewEncapsulation, OnInit, Inject } from "@angular/core";
import { FormGroup } from "@angular/forms";
import { DataRepositoryService } from "../../../services/datarepository/datarepository.service";
import { Router, ActivatedRoute } from "@angular/router";
import { MatDialogRef, MAT_DIALOG_DATA } from "@angular/material";
import { DataRepositoryModel } from "../../../models/dataRepositories/DataRepositoryModel";

@Component({
  selector: 'app-datarepository-referenced-model-helper',
  templateUrl: 'datarepository-referenced-model-helper.component.html',
  styleUrls: ['./datarepository-referenced-model-helper.component.scss'],
  encapsulation: ViewEncapsulation.None
})
export class DataRepositoryReferencedModelHelperComponent implements OnInit {
  public formGroup: FormGroup;

  constructor(
    private dataRepositoryService: DataRepositoryService,
    private route: ActivatedRoute,
    public router: Router,
    public dialogRef: MatDialogRef<DataRepositoryReferencedModelHelperComponent>,
    @Inject(MAT_DIALOG_DATA) public data: any
  ) { }

  ngOnInit(): void {
    let datarepo = new DataRepositoryModel();
    this.formGroup = datarepo.buildForm();
  }


  send(value: any) {
    this.dataRepositoryService.create(this.formGroup.value).subscribe(
      (item)=> this.dialogRef.close(item)
    );
  }
}
