import { ExternalDatasetModel } from "../../../models/external-dataset/ExternalDatasetModel";
import { MatDialogRef, MAT_DIALOG_DATA } from "@angular/material";
import { Inject, ViewEncapsulation, Component, OnInit } from "@angular/core";
import { ActivatedRoute, Router } from "@angular/router";
import { ExternalDatasetService } from "../../../services/external-dataset/external-dataset.service";
import { FormGroup } from "@angular/forms";

@Component({
  selector: 'app-externaldataset-referenced-model-helper',
  templateUrl: 'externaldataset-referenced-model-helper.component.html',
  styleUrls: ['./externaldataset-referenced-model-helper.component.scss'],
  encapsulation: ViewEncapsulation.None
})
export class ExternalDatasetReferencedModelHelperComponent implements OnInit {
  public formGroup: FormGroup;

  constructor(
    private externalDatasetService: ExternalDatasetService,
    private route: ActivatedRoute,
    public router: Router,
    public dialogRef: MatDialogRef<ExternalDatasetReferencedModelHelperComponent>,
    @Inject(MAT_DIALOG_DATA) public data: any
  ) { }

  ngOnInit(): void {
    let externalDatasetModel = new ExternalDatasetModel();
    this.formGroup = externalDatasetModel.buildForm();
  }


  send(value: any) {
    this.externalDatasetService.create(this.formGroup.value).subscribe(
      (item)=> this.dialogRef.close(item)
    );
  }
}
