import { Component, Input, OnInit, AfterViewChecked, ViewChild } from '@angular/core';
import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { DatasetProfileAdmin } from '../services/datasetProfileAdmin/datasetProfileAfmin.service';
import { HostConfiguration } from '../app.constants';
import { Observable } from 'rxjs/Observable';
import { RequestItem } from '../models/criteria/RequestItem';
import { AutocompleteLookupItem } from '../models/auto-complete/AutocompleteLookupItem';

@Injectable()
export class DatasetProfileService {

  private actionUrl: string;
  private headers: HttpHeaders;

  constructor(private httpClient: HttpClient, private datasetProfileAdmin: DatasetProfileAdmin) {
    this.actionUrl = HostConfiguration.Server + 'datasetwizard/';

    this.headers = new HttpHeaders();
    this.headers = this.headers.set('Content-Type', 'application/json');
    this.headers = this.headers.set('Accept', 'application/json');
  }

  fetchAllDatasetProfiles() {
    // return this.restBase.get("datasetprofiles/getAll");
  }

  getDatasetProfileById(datasetProfileID) {
    return this.datasetProfileAdmin.getDatasetProfileById(datasetProfileID);
  }

  createDatasetProfile(datasetProfile) {
    // return this.restBase.post("datasetprofile/create", datasetProfile);
  }

  updateDatasetProfile(datasetProfile) {
    // return this.restBase.post("datasetprofile/update", datasetProfile);
  }

  delete(datasetProfile) {
    //  return this.restBase.post("datasetprofile/delete", datasetProfile);
  }

  queryAutocomplete(lookUpItem: RequestItem<AutocompleteLookupItem>): Observable<any> {
    return this.httpClient.post(HostConfiguration.Server + "search/autocomplete", lookUpItem)
  }


}
