import { JsonSerializer } from '../../../utilities/JsonSerializer';
import { RequestItem } from '../../../models/criteria/RequestItem';
import { Component, OnInit, Inject } from "@angular/core";
import { FormGroup } from '@angular/forms';
import { Params, ActivatedRoute, Router } from '@angular/router';
import { MAT_DIALOG_DATA, MatDialogRef } from '@angular/material';
import { ResearcherModel } from '../../../models/researcher/ResearcherModel';
import { ResearcherService } from '../../../services/researchers/researchers.service';

@Component({
  selector: 'add-researchers-component',
  templateUrl: 'add-researchers.component.html',

})
export class AddResearchersComponent implements OnInit {

  public formGroup: FormGroup;

  constructor(
    private researcherService: ResearcherService,
    private route: ActivatedRoute,
    public router: Router,
    public dialogRef: MatDialogRef<AddResearchersComponent>,
    @Inject(MAT_DIALOG_DATA) public data: any
  ) { }

  ngOnInit(): void {
    let researcher = new ResearcherModel();
    this.formGroup = researcher.buildForm();
  }


  send(value: any) {
    this.researcherService.createResearcher(this.formGroup.value).subscribe(
      null, null, () => this.dialogRef.close()
    );
  }
}
