import { Observable } from 'rxjs';

export interface SingleAutoCompleteConfiguration {
	// Delay for performing the request. Default: 200ms.
	requestDelay?: number;
	// Min characters for the filtering to be applied. Default: 3.
	minFilteringChars?: number;
	// Load and present items from start, without user query. Default: true.
	loadDataOnStart?: boolean;
	// Static or initial items.
	items?: Observable<any[]>;
	// Data retrieval function
	filterFn?: (searchQuery: string) => Observable<any[]>;
	// Property formating for input
	displayFn?: (item: any) => string;
	// Property formating for dropdown
	titleFn?: (item: any) => string;
	// Property formating for dropdown
	subtitleFn?: (item: any) => string;
}
