﻿import { AutocompleteData } from '../../../models/DataField/AutocompleteData';
import { FormGroup } from '@angular/forms';
import { Component, Input, OnInit } from '@angular/core';
import { FormArray } from '@angular/forms';
import { Field } from '../../../models/datasetProfileAdmin/Field';
import { JsonSerializer } from '../../../utilities/JsonSerializer';

@Component({
  selector: 'autocomplete-component',
  styleUrls: ["./autocomplete-component.scss"],
  templateUrl: './autocomplete-component.html'
})
export class AutocompleteComponent implements OnInit {
  @Input() dataModel: Field;
  @Input() form: FormGroup;
  private data: AutocompleteData = new AutocompleteData();

  ngOnInit() {
    this.data.type = "autocomplete";
    if (!this.form.get("data") || !this.form.get("data").get("autoCompleteOptions")) {
      let autocomplete: AutocompleteData = new AutocompleteData();
      this.dataModel.data = JsonSerializer.fromJSONObject(this.data, AutocompleteData);
      this.form.removeControl("data");
      this.form.addControl("data", autocomplete.buildForm());
    } else {
      this.form.addControl("data", this.data.buildForm());
    }
  }
}
