import { BaseCriteriaComponent } from './components/criteria/base/base-criteria.component';
import { FigurecardComponent } from './components/figurecard/figurecard.component';
import { CommonModule } from '@angular/common';
import { FlexLayoutModule } from '@angular/flex-layout';

import { NgModule, LOCALE_ID } from '@angular/core';
import { RouterModule } from '@angular/router';
import { NavigationComponent } from './components/navigation/navigation.component';
import { SnackBarNotificationComponent } from './components/notificaiton/snack-bar-notification.component';
import { MaterialModule } from './material/material.module';
import { TranslateModule } from '@ngx-translate/core';
import { ProjectCriteriaComponent } from './components/criteria/projects/projects-criteria.component';
import { DatasetCriteriaComponent } from './components/criteria/datasets/datasets-criteria.component';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { DataManagementPlanCriteriaComponent } from './components/criteria/data-management-plan/dmp-criteria.component';
import { FileUploaderComponent } from '../shared/components/file-uploader/file-uploader.component';
import { UrlListingComponent } from '../shared/components/url-listing/url-listing.component';
import { NgForLimitPipe } from './pipes/ngforlimit/ngforlimit.pipe';
import { DataManagementPlanProfileCriteriaComponent } from './components/criteria/datamanagementplanprofile/dmp-profile-criteria.component';
import { AutoCompleteComponent } from './components/auto-complete/auto-complete.component';
import { ExternalItemListingComponent } from './components/external-items/external-item-listing/external-item-listing.component';
import { ExternalItemComponent } from './components/external-items/external-item/external-item.component';
import { BreadcrumbComponent } from './components/breadcrumb/breadcrumb.component';
import { SingleAutoCompleteComponent } from './components/autocompletes/single/single-auto-complete.component';
import { MultipleAutoCompleteComponent } from './components/autocompletes/multiple/multiple-auto-complete.component';
import { UserDialogComponent } from './components/user-dialog/user-dialog.component';
import { SearchBarComponent } from './components/search-bar/search-bar.component';
import { TimezoneInfoDisplayPipe } from '../utilities/culture/pipes/TimezoneInfoDisplayPipe';
import { CultureService } from '../utilities/culture/culture-service';
import { MAT_DATE_LOCALE } from '@angular/material';
import { FacetSearchComponent } from './components/facets/facet-search.component';
import { FacetSearchSectionComponent } from './components/facets/facet-search-component/facet-search-section.component';

@NgModule({
	imports: [
		CommonModule,
		RouterModule,
		MaterialModule,
		FlexLayoutModule,
		TranslateModule,
		FormsModule,
		ReactiveFormsModule
	],

	declarations: [
		NavigationComponent,
		SnackBarNotificationComponent,
		ProjectCriteriaComponent,
		DatasetCriteriaComponent,
		DataManagementPlanCriteriaComponent,
		DataManagementPlanProfileCriteriaComponent,
		FigurecardComponent,
		BaseCriteriaComponent,
		FileUploaderComponent,
		UrlListingComponent,
		NgForLimitPipe,
		AutoCompleteComponent,
		ExternalItemListingComponent,
		ExternalItemComponent,
		BreadcrumbComponent,
		SingleAutoCompleteComponent,
		MultipleAutoCompleteComponent,
		UserDialogComponent,
		SearchBarComponent,
		FacetSearchComponent,
		FacetSearchSectionComponent
	],

	exports: [
		MaterialModule,
		FlexLayoutModule,
		NavigationComponent,
		SnackBarNotificationComponent,
		ProjectCriteriaComponent,
		DatasetCriteriaComponent,
		DataManagementPlanProfileCriteriaComponent,
		DataManagementPlanCriteriaComponent,
		FigurecardComponent,
		BaseCriteriaComponent,
		FileUploaderComponent,
		UrlListingComponent,
		NgForLimitPipe,
		AutoCompleteComponent,
		ExternalItemListingComponent,
		ExternalItemComponent,
		BreadcrumbComponent,
		SingleAutoCompleteComponent,
		MultipleAutoCompleteComponent,
		UserDialogComponent,
		FacetSearchComponent,
		FacetSearchSectionComponent
	],
	entryComponents: [
		UserDialogComponent
	],

})

export class SharedModule { }
